format    pe64 console 6.0
include  'win64ax.inc'
include  'equates\peb64.inc'
entry     start
;//-----------
section '.data' data readable writable

counter  dq  1
buff     dq  0

;//-----------
section '.text' code readable executable
start:   sub     rsp,8
         invoke  SetConsoleTitle,<' *** PEB struct parser v0.1 ***',0>

;//-----      --------------------------
         mov     rsi, [gs:0x60]
         push    rsi
         movzx   eax, [rsi + PEB.BeingDebugged]
         mov     ebx, [rsi + PEB.NtGlobalFlag]
         mov     r10d,[rsi + PEB.NumberOfProcessors]
        cinvoke  printf,<10,' BeingDebugged.......: %d',\
                         10,' NtGlobalflag........: 0x%x',\
                         10,' ImageBase...........: 0x%016I64x',\
                         10,' ProcessHeap.........: 0x%016I64x',\
                         10,' ProcessorCores......: %d',10,0>,rax,rbx,\
                         [rsi + PEB.ImageBaseAddress],\
                         [rsi + PEB.ProcessHeap],r10

         pop     rsi
         push    rsi
        cinvoke  printf,<10,' LdrLoaderData.......: 0x%016I64x',\
                         10,' SharedMemoryBase....: 0x%016I64x',\
                         10,' StaticServerData....: 0x%016I64x',\
                         10,' ProcessParameters...: 0x%016I64x',10,0>,\
                         [rsi + PEB.Ldr],\
                         [rsi + PEB.ReadOnlySharedMemoryBase],\
                         [rsi + PEB.ReadOnlyStaticServerData],\
                         [rsi + PEB.ProcessParameters]
         pop     rsi
         push    rsi
         mov     eax, [rsi + PEB.OSMajorVersion]
         mov     ebx, [rsi + PEB.OSMinorVersion]
         movzx   ebp, [rsi + PEB.OSBuildNumber]
         mov     r10d,[rsi + PEB.OSPlatformId]
         mov     r11, [rsi + PEB.CSDVersion]
        cinvoke  printf,<10,' OSMajorVersion......: %d',\
                         10,' OSMinorVersion......: %d',\
                         10,' OSBuildNumber.......: %d',\
                         10,' OSPlatformId........: %d',\
                         10,' CSDVersion..........: %ls',10,0>,\
                         rax,rbx,rbp,r10,r11

;//-----     LDR_DATA_TABLE_ENTRY --------

        cinvoke  printf,<10,' ##      BaseAddr         EntryPoint     InMemory  Name',\
                         10,' --  ----------------  ----------------  --------  ----------',0>
         pop     rsi
         push    rsi
         mov     rsi,[rsi + PEB.Ldr]
         mov     rsi,[rsi + PEB_LDR_DATA.InLoadOrderModuleList]     ; LDR_DATA_TABLE_ENTRY
         mov     rax,[rsi + LDR_DATA_TABLE_ENTRY.InLoadOrderLinks+8]
         mov     [buff],rax

@@:      push    rsi
         mov     rbx,[rsi + LDR_DATA_TABLE_ENTRY.BaseDllName+8]
         mov     eax,[rsi + LDR_DATA_TABLE_ENTRY.SizeOfImage]
         shr     eax,10
        cinvoke  printf,<10,' %02d  %016I64x  %016I64x  %5d Kb  %ls',0>,[counter],\
                             [rsi + LDR_DATA_TABLE_ENTRY.DllBase],\
                             [rsi + LDR_DATA_TABLE_ENTRY.EntryPoint],rax,rbx
         pop     rsi
         inc     [counter]
         mov     rsi,[rsi + LDR_DATA_TABLE_ENTRY.InLoadOrderLinks]
         cmp     rsi,[buff]
         jnz     @b

;//-----    RTL_USER_PROCESS_PARAMETERS -----------------
         pop     rsi
         mov     rsi,[rsi + PEB.ProcessParameters]
         mov     rax,[rsi + RTL_USER_PROCESS_PARAMETERS.ConsoleHandle]
         mov     rbx,[rsi + RTL_USER_PROCESS_PARAMETERS.StandardInput]
         mov     rdi,[rsi + RTL_USER_PROCESS_PARAMETERS.StandardOutput]
         mov     rbp,[rsi + RTL_USER_PROCESS_PARAMETERS.Environment]
         mov     r10,[rsi + RTL_USER_PROCESS_PARAMETERS.ImagePathName+8]
         mov     r11,[rsi + RTL_USER_PROCESS_PARAMETERS.ShellInfo+8]
         push    rbp
        cinvoke  printf,<10,\
                         10,' Console   Handle....: 0x%04x <---- DANGER! Attacks possible!',\
                         10,' StdInput  Handle....: 0x%02x',\
                         10,' StdOutput Handle....: 0x%02x',\
                         10,' Environment.........: 0x%08I64x',\
                         10,' Window Title........: %ls',\
                         10,' PowerShell Path.....: %ls',10,0>,rax,rbx,rdi,rbp,r10,r11

;//-----    -----------------------------
         pop     rsi
         add     rsi,10h
         mov     rcx,10
@@:      push    rsi rcx
         mov     rdi,buff
@copy:   lodsw
         stosb
         or      ax,ax
         jnz     @copy
        cinvoke  CharToOem,buff,buff
        cinvoke  printf,<10,' %s',0>,buff
         pop     rcx rsi
         shl     eax,1
         sub     rax,2
         add     rsi,rax
         loop    @b

;//-----   KUSER_SHARED_DATA ----------------------------
         mov     rsi,0x7ffe0000
         movzx   eax, [rsi + KUSER_SHARED_DATA.ImageNumberLow]
         mov     ebx, [rsi + KUSER_SHARED_DATA.ActiveConsoleId]
         mov     ebp, [rsi + KUSER_SHARED_DATA.NumberOfPhysicalPages]
         imul    rbp, 4096
         shr     rbp, 20
         movzx   edi, [rsi + KUSER_SHARED_DATA.ActiveGroupCount]
         mov     r10d,[rsi + KUSER_SHARED_DATA.ActiveProcessorCount]
         mov     r11, [rsi + KUSER_SHARED_DATA.TickCount]
         imul    r11d,[rsi + KUSER_SHARED_DATA.TickCountMultiplier]
        cinvoke  printf,<10,\
                         10,' ******* KUSER_SHARED_DATA *******',\
                         10,' ImageNumber.........: 0x%04x',\
                         10,' ConsoleId...........: 0x%02x',\
                         10,' PhysicalMemory......: %u Mb',\
                         10,' TotalProcessors.....: %d',\
                         10,' ProcessorCores......: %d',\
                         10,' TickCount...........: %I64u',10,0>,rax,rbx,rbp,rdi,r10,r11

@exit:  cinvoke  _getch      ;//<---- GAME OVER! ---------------//
        cinvoke  exit, 0
;//-----------
section '.idata' import data readable
library  kernel32,'kernel32.dll', user32,'user32.dll',msvcrt,'msvcrt.dll'
include 'api\kernel32.inc'
include 'api\user32.inc'
include 'api\msvcrt.inc'
